/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <windows.h>
#include  <stdio.h>
#include  <string>
#include  "../common/graphics/gltext.h"
#include  "mtk_font.h"
#include  "mtk_directory.h"
#include  "mtk_text.h"
#include  "mtk_screen.h"

using namespace std;



// eLXg
static gltext  endroll_J, endroll_E;

//
static float width    = 100;
static float DY       = 0.0;
static float duration = 10.0;
static float angle    = 0.0;


static char credit_roll_filename_J[MAX_PATH];
static char credit_roll_filename_E[MAX_PATH];
static bool bLoadedEndrollJ = false;
static bool bLoadedEndrollE = false;


bool
load_endroll_text(const char* fn, gltext& glt)
{
	FILE* fp;


	glt.clear();

	// t@CXNvgǂݍ
	directory dir = get_directory(DIR_TITLE);
	if ( (fp = dir.fopen(fn, "rt")) == NULL)  return false;

	string buf;
	int ch;
	while ( (ch=getc(fp)) != EOF ) {
		buf.push_back(char(ch));
	}
	buf.push_back('\0');
	fclose(fp);

	return  glt.set_text(buf.c_str());
}



void
set_credit_roll_filename_J(const char* fn)
{
	strcpy(credit_roll_filename_J, fn);
}

void
set_credit_roll_filename_E(const char* fn)
{
	strcpy(credit_roll_filename_E, fn);
}


void
init_credit_roll_text()
{
	static bool bLoaded = false;

	if (bLoaded)  return;

	bLoadedEndrollJ = load_endroll_text(credit_roll_filename_J, endroll_J);
	bLoadedEndrollE = load_endroll_text(credit_roll_filename_E, endroll_E);

	bLoaded = true;
}


void
draw_credit_roll(float frac)
{
	char lng = get_language();
	gltext& endroll = (lng == LANG_ENG)  ?  endroll_E  :  endroll_J;
	if (lng == LANG_ENG && !bLoadedEndrollE)  return;
	if (lng != LANG_ENG && !bLoadedEndrollJ)  return;

	wgl_font& fnt = get_font();

	gltext_block_size bsz;
	bsz = endroll.get_total_size(fnt);


	float scl = width / bsz.w;
	float total_h = bsz.hu - bsz.hd;
	float dy = total_h * frac;
	float y = dy - total_h + DY/scl;

	glPushMatrix();
		glScalef(scl, scl, scl);
		glRotatef(-angle, 1, 0,0);
		glTranslatef(-0.5*bsz.w, y, 0);
		glColor3f(1,1,1);
		endroll.draw(fnt);
	glPopMatrix();
}


//-----------
//  Set/Get
//-----------
void
set_credit_roll_width(float w)
{
	width = w;
}

float
get_credit_roll_width()
{
	return width;
}

void
set_credit_roll_dy(float dy)
{
	DY = dy;
}

float
get_credit_roll_dy()
{
	return DY;
}

void
set_credit_roll_duration(float dur)
{
	duration = dur;
}

float
get_credit_roll_duration()
{
	return duration;
}

void
set_credit_roll_angle(float ang)
{
	angle = ang;
}

float
get_credit_roll_angle()
{
	return angle;
}




//---------
//  
//---------
static gltext txtCautionJ(
	"\\Center \\Size[0.45] \\Vspace[1.0] \\\\"
	"\\Color[1,0.8,0.2] \\Cdot CȂΌKl͂ĉ\\\\\\Vspace[0.5]"
	"\\Color[1,1,1] \\Cdot XN[ɐGȂŉ\\\\\\Vspace[0.5] "
	"\\Cdot gѓdb̓d͂؂艺\\\\\\Vspace[0.5] "
	"\\Cdot f̈H͂"
);


static gltext txtCautionJH(
	"\\Center \\\\\\Size[0.45] \\Vspace[1.0] \\\\"
	"\\Color[1,0.8,0.2] \\Cdot {C|Ԃ}{|}Ȃ{Ό|ւ񂱂}Kl͂{|}\\\\\\Vspace[0.5]"
	"\\Color[1,1,1] \\Cdot XN[{G|}Ȃŉ\\\\\\Vspace[0.5] "
	"\\Cdot {gѓdb|ł}{d|ł񂰂}͂{|}{|}\\\\\\Vspace[0.5] "
	"\\Cdot {f|傤イ}{H|񂵂傭}͂{|}{|}"
);


static gltext txtCautionE(
	"\\Center Please...\\Size[0.45] \\Vspace[1.0] \\\\"
	"\\Color[1,0.8,0.2] \\Cdot If you feel sick, take off your glasses.\\\\\\Vspace[0.5]"
	"\\Color[1,1,1] \\Cdot Do not touch the screen.\\\\\\Vspace[0.5] "
	"\\Cdot Turn off cell phones and other noise makers.\\\\\\Vspace[0.5] "
	"\\Cdot Do not eat or drink during the presentation."
);



void
draw_title_caution()
{
	char lng = get_language();

	gltext& txtCaution = (lng == LANG_ENG)  ?  txtCautionE  :  ( (lng == LANG_KNJ)  ?  txtCautionJ  :  txtCautionJH );
	wgl_font& fnt = get_font();
	gltext_block_size bsz;
	bsz = txtCaution.get_total_size(fnt);

	float scl = 0.8 * get_screen_w() / bsz.w;
	float total_h = bsz.hu - bsz.hd;

	glPushMatrix();
		glScalef(scl, scl, scl);
		glTranslatef(-0.5*bsz.w, -0.5*total_h, 0);
		glColor3f(1,1,1);
		txtCaution.draw(fnt);
	glPopMatrix();
}



