/**************************************************************************************************

Copyright (c) 2007-2012   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_MOVIE_H__
#define __MTK_MOVIE_H__
#include  <dshow.h>
#include  <vector>
using namespace std;
#include  "../common/win_file.h"




//--------------------------
//  Movie using DirectShow
//--------------------------
class movie
{
	//--- DirectShow Interfaces ---
	IGraphBuilder*  pGB;
	IMediaControl*  pMC;
	IMediaEventEx*  pEv;
	IVideoWindow*   pVW;	// Video window
	IBasicAudio*	pBA;	// Audio
	IBasicVideo*	pBV;	// Video
	IMediaSeeking*  pMS;	//

	IVMRWindowlessControl*	pWC;
	IVMRMixerControl*		pMix;
	//
	LONGLONG  end_pos;	// [r[̏Iʒu

	bool			bMovie;		// [r[ǂ
	int				mvx, mvy;	// [r[EBhËʒu
	int				mvw, mvh;	// [r[EBhẼTCY

public:
	movie() : pGB(NULL), pMC(NULL), pEv(NULL), pVW(NULL), pBA(NULL), pBV(NULL), pMS(NULL),
				pWC(NULL), pMix(NULL), end_pos(0), bMovie(false) {};
	~movie() { ReleaseDirectShow(); }

	// Open
	bool	open(const char* filename, HWND hOwnerWindow, int x0, int y0, int w, int h, UINT u_WM_NOTIFY, bool bWindowlessVMR);

	// Play
	void	play();
	void	pause();
	void	home();
	void	end();
	void	close();

	// Position
	LONGLONG	get_end_position() const		{ return end_pos; }
	LONGLONG	get_position() const;
	void		set_position(LONGLONG pos);

	// Event
	bool		get_event(long& evCode, long& prm1, long& prm2);

	bool		is_movie() const				{ return bMovie; }

	// Accesor
	int			get_x() const	{ return mvx; }
	int			get_y() const	{ return mvy; }
	int			get_w() const	{ return mvw; }
	int			get_h() const	{ return mvh; }


	void		OnPaint(HWND hWnd, HDC hDC);


private:
	void	ReleaseDirectShow();
	HRESULT	InitializeWindowlessVMR(HWND hOwnerWindow);
};





//=======================
//  fBAt@C̊Ǘ
//=======================
const  int media_files_max = 30;	// ő̃t@C


//-----------------------
//  fBAt@C̏
//-----------------------
struct  media_file_info
{
	char	filename[MAX_PATH+1];	// t@C
	char	filename2[MAX_PATH+1];	// t@Ci[hpj
	char	type;					// fBA̎
	char	menu_title[256];		// j[p̃^Cg
	char	disp_title[256];		// \p̃^Cg
};

//---------------------
// fBAt@C̎
//---------------------
enum {
	MEDIATYPE_IMAGE,
	MEDIATYPE_POPUP_IMAGE,
	MEDIATYPE_MOVIE,
	MEDIATYPE_AUDIO
};





//----------------------------
//  fBAt@CNX
//----------------------------
class  MediaFiles  :  public vector<media_file_info>
{
public:
	MediaFiles() {}

	bool	open_info_file(const directory& dir, const char* fn);
	bool	load_pathfile(int idx, char file_path[][MAX_PATH], bool bSubtitlesMode) const;
};





#endif